#define Version "170128"

// enlev la partie ADC0
// enlev Timer0
// attention Relais_LC actif au niveau 0 !  because avec transistor de cde
//    relai_CCalc actif au niveau 1

//#define Version "170127"

#define Langage "MikroC 7.0.0"
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F1847_LC_Meter_LM311"
#define Projet "16F1847_LCMeter_BT_2017.mcppi"
#define Source "_16F1847_LCMeter_BT"      // sans extension !
#define MCU "16F1847"
#define POWER_SUPPLY "5V"    // (3,3 to 4,2V battery)
//#define OSCILLATEUR_INTERNE
#define EEPROM_FILE "16F1847_LCMeter_BT_2017_Eeprom.ihex"


#ifdef OSCILLATEUR_INTERNE
#define FOSC "Interne 8MHz"
//  FOSC interne 8 MHz
//  P16F1847_Fosc_interne_8MHZ.cfgsch
//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1613
#else
#define FOSC " Q=8MHz"
//P16F1847_Q8MHZ.cfgsch
//CONFIG1 : $8007 : 0x39E2
//CONFIG2 : $8008 : 0x1613
#endif

#define With_LCD_I2C
//#define Test_UART

 //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define BELL 7

 //ac:Pinout_16F1847_LCMeter
 
  //ac:LCMeter_Formula
 

/// Hardware 16F1847  DIP18 :
/*
 -Alim 5V
PIN 1    RA2/AN2 or DACOUT  ---output -- Relay CCal
PIN 2    RA3 AN3   libre
PIN 3    RA4/AN4  Timer0 input  ---output -- Relay Module Bleu  LC

                    |---750--ICSP VPP  PIN 1 Pickit2
Pin 4     RA5/ MCLR |--- 6,8K --- +5V
Pin 5     VSS et ------------ICSP Gnd Pin 3  Pickit2
pin 6     RB0    Input <--- Switch choix L ou C
pin 7     RB1 Alternate to  SDA1------I2C bus  ----2,7K --+5V
pin 8     RB2 RX UART  <--- vert  <-- TX  Prolic 23023 PC COM
pin 9     RB3/AN9/ CCP1/P1A   <---  Swirtch Calibration
-----
Pin 18    RA1   libre
Pin 17    RA0   libre   (was EA0)
Pin 16    RA7 ----------------  Q 8MHz ----33pF- ||----/
Pin 15    RA6 ---------------   Q 8Mhz ----33pF--||----/
pin 14    VDD -----------------+5V
pin 13    RB7/AN6--- 750 --- ICSPDAT   Pin 4   Pickit2
pin 12    RB6/AN5--- 750 --- ICSPCLCK  Pin 5   Pickit2
pin 11    RB5/AN5   Alternate to TX UART    ---> blanc  --> RX  Prolic 23023 PC COM
pin 10    RB4 SCL1 ----------I2C BUS ---2,7K --- +5V
  */
  
 #include "built_in.h"     // for  Hi  Lo ..etc
 
#ifdef With_LCD_I2C
// **********  Config Hardware **********************
#define LCD_ADDR 0x4E     // PCF8574 on pigboard YwRobot back located  on LCD4x20
// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1
#include "../common/Lib_LCD_I2C.h"
#endif


#include "../common/Delays.h"

sbit Relay_CCal at PORTA.B2;
sbit Relay_CCal_Direction at TRISA2_bit;
sbit Relais_LC at PORTA.B4  ;
sbit Relais_LC_Direction at TRISA4_bit;
sbit Demande_Cal at PORTB.B3;
sbit Demande_Cal_Direction at TRISB3_bit;
sbit Choix_LC  at  PORTB.B0;
sbit Choix_LC_Direction   at TRISB0_bit;

const code char mesg0[]="                    "; // 20 blancs pour effacer la ligne LCD
const code char mesg1[]=" Compilateur : "Langage"\n\r";
const code char mesg2[]=" Directory :"Directory"\r\n";
const code char mesg3[]=" Projet    :"Projet"\r\n";
const code char mesg4[]=" Source    :"Source"\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4};

char TEXTE[80];
char * txt;
char CRam1[64];
char *p;
unsigned int i,j,k,l,m;

#define MAXLEN1 80
#define Rapport   0.0253302959106          // (2*PI)^2
#define F1Nominal  55500
#define F2Nominal  38920
//#define Cde_by_Harware

// UART & Texte variables
unsigned char buffer1[MAXLEN1];
unsigned int Index1=0;
unsigned int UART1_DataReady=0;
unsigned int i1=0;
unsigned char c1;
int CptErr;

// LC meter variables
unsigned int k1,k2,k3;
float f0,f1,f2,f3,f12,f13,f14,Cx,Lx;
unsigned int Stabilite=0;
unsigned int MemoModeLC=0;

unsigned int Cpt1;   // timer1 overflow count
int Etat;
int addr;


void Read_Msg_Eeprom(unsigned char depuis);
void Init_Hardware(void);
void Init_Timer1(void);
void Float2Ascii (float x, unsigned char *str,char precision);
void strConstRamCpy(char *dest, const char *source);
void Special_Init_UART_RB2_RB5(void);
void RAZ_UART1(void);
void UART1_Write_CText(const char *txt1);
void CRLF1(void);
unsigned int  Take_Fx(char Cmode);


void Interrupts() iv 0x0004 ics ICS_AUTO 
{
  if ( (RCIE_bit) && ( PIR1.RCIF))
   {
    //  TXREG='@';
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      UART1_DataReady=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
        if (i1>=MAXLEN1) i1=0;
      }
   }
}


void RAZ_UART1()
{      int i1;
      for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
      Index1=0;
      i1=0;
      c1=RCREG;  // vide le buffer RCREG
      c1=0;
      UART1_DataReady=0;
     // REGISTER 8-2: PIE1: PERIPHERAL INTERRUPT ENABLE REGISTER 1
      PIE1.RCIE=1 ;
}

void UART1_Write_CText(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*(txt1++));
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source)
 {
  while(*source) *(dest++) = *(source++) ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
  UART1_Write(LF);
 }

void Read_Msg_Eeprom(unsigned char debut)
{   int i1 ;
unsigned char c;
  i1=debut;
  do
  {
  c = EEPROM_Read(i1);
  if ( c==0) break;
  if ( i1>254) break;
  UART1_Write(c);
  Delay_ms(5);
  i1++;
   }
  while (c!=0) ;
 }

void Init_Hardware()
{
  TRISB  = 0xFF;
  TRISA  = 0xFF;
  PORTA=0;
  //ANSELA = 0b00000001;  //  RA0 as analog
  ANSELA = 0b00000000;  // NO analog
  Relay_CCal_Direction=0;
  Relais_LC_Direction=0;
  Relais_LC=1;
  Relay_CCal=0;
 //
  ANSELB = 0;           // PORTB en Digital
 // If Configuration Word 1 , MCLR is enabled Weak Pull-up is always enabled.
  WPUA5_bit=1;
  WPUB=0;  // no pullup
  //Global WPUEN bit of the OPTION_REG register must be cleared for individual pull-ups to be enabled
  TRISB.B1 = 1;  // SDA1 I2C
  TRISB.B4 = 0;  // SCL1 I2C
  TRISB.B5 = 0;  // TX UART
  TRISB.B2 = 1;  // RX UART
  TRISB.B6 = 1;  // Timer1 input
  Choix_LC_Direction=1;      // RB0
  Demande_Cal_Direction=1;   //RB3

  CM1CON0=0;       // disable comparators 1
  CM1CON1=0;
  CM2CON0=0;       // disable comparators  2
  CM2CON1=0;
}

void Special_Init_UART1_RB2_RB5(void)
{
  //DS41453B-page 120
 /* bit 7 RXDTSEL: Pin Selection bit
  0 = RX/DT function is on RB1
  1 = RX/DT function is on RB2
  bit 6 SDO1SEL: Pin Selection bit
  0 = SDO1 function is on RB2
  1 = SDO1 function is on RA6
  bit 5 SS1SEL: Pin Selection bit
      0 = SS1 function is on RB5
      1 = SS1 function is on RA5
      */

  APFCON0.SDO1SEL=1; //0 = SDO1 function is on RB2 , 1 = SDO1 function is on RA6
  APFCON0.SS1SEL=1;  // 1 = SS1 function is on RA5
  APFCON0.RXDTSEL=1; // 1 = RX/DT function is on RB2
  APFCON1.TXCKSEL=1;     // RB5 as TX UART
  BAUDCON.WUE=0;  //Wake-up Enable bit  0 = Receiver is operating normally
  CPSCON0 = 0 ;//CAPACTIVE SENSE MODULE OFF
  TRISB.B2=1;
 }


void Init_Timer1(void)
{
 //REGISTER 21-1: T1CON: TIMER1 CONTROL REGISTER   DS41453B-page 187
 // TMR1CS<1:0> T1CKPS<1:0> T1OSCEN T1SYNC  TMR1ON
 T1CON=0;
 //TMR1CS<1:0>: Timer1 Clock Source Select bits
 //TABLE 21-2: CLOCK SOURCE SELECTIONS
 //TMR1CS1 TMR1CS0 T1OSCEN   Clock Source
 // 1        0        0     External Clocking on T1CKI Pin
 //  10 =Timer1 clock source is pin or oscillator:
 // If T1OSCEN = 0:  External clock from T1CKI pin (on the rising edge)
 TMR1CS1_bit=1;
 TMR1CS0_bit=0;
 //T1CKPS<1:0>: Timer1 Input Clock Prescale Select bits
 //00 = 1:1 Prescale value
 T1CKPS1_bit=0;
 T1CKPS0_bit=0 ;
 T1OSCEN_bit=0;
 T1CON.B2=1; // T1SYNC=1  1 = Do not synchronize external clock input;
 // TMR1ON TMR1GE Timer1 Operation
// 0        0            Off
// 0        1            Off
// 1        0            Always On
 TMR1ON_bit=1;
 //REGISTER 21-2: T1GCON: TIMER1 GATE CONTROL REGISTER
//  TMR1GE T1GPOL T1GTM T1GSPM T1GGO/DONE   T1GVAL T1GSS<1:0>
  TMR1GE_bit=0;   //Timer1 Gate Enable bit Timer1 counting is controlled by the Timer1 gate function
  T1GPOL_bit=0;  // T1GPOL: Timer1 Gate Polarity bit   1 = Timer1 counts when gate is high)
  T1GTM_bit=0;         //Timer1 gate flip-flop toggles on every rising edge.
  T1GSPM_bit=0; // Timer1 Gate Single-Pulse Mode bit disabled
 // Timer1 gate Source  T1GSS<1:0>: Timer1 Gate Source Select bits 00 Timer1 Gate Pin
 T1GSS1_bit=0;
 T1GSS0_bit=0;
 Cpt1=0;
 //10 = Comparator 1 optionally synchronized output (SYNCC1OUT)
}


void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}

unsigned int  Take_Fx(char Cmode)
{   char x;
unsigned int K;
    switch(Cmode)
    {
     case 1:
        x='1';
        Relay_CCal=0;
        strConstRamCpy(txt,"F1 Zero=1nf :      0");
        break;
     case 2:
       x='2' ;
       Relay_CCal=1;
       strConstRamCpy(txt, "F2 Scale=2nf:      0");
        break;
     case 3:
        x='X';
        Relay_CCal=0;
        strConstRamCpy(txt,"F3(Mesure):        0");
        break;
     }
    Delay_ms(1000);
    TMR1IF_bit=0;
    TMR1L=0;
    TMR1H=0;
    TMR1ON_bit=1;           // arme timer1
    Delay_ms(100);          // fenetre de comptage
    TMR1ON_bit=0;           // stop timer1
    K=(TMR1H<<8) + TMR1L;   // lecture Timer1
    if(TMR1IF_bit) Cpt1++;
    WordToStr(K,CRam1);
    memcpy(txt+14,CRam1,5);
    UART1_Write_Text(txt);
    CRLF1();
     switch(Cmode)
    {
     case 1:
        LCD_putcmd(LCD_LINE2,1);
        break;
     case 2:
       if(MemoModeLC==2) LCD_putcmd(LCD_LINE3,1);
      Relay_CCal=0;
       break;
     case 3:
       if(MemoModeLC==2) 
          LCD_putcmd(LCD_LINE4,1);
          else
           LCD_putcmd(LCD_LINE3,1);
       Relay_CCal=0;
        break;
     }
    Delay_ms(25);
    LCD_puts(txt);
    Delay_ms(1500);
    return K;
  }
  
  
void Calibration_CCal()
{  Cpt1=0;
   MemoModeLC=2;
   Relais_LC=1; // repos
   Relay_CCal=0;
   Delay_ms(1000);
  // UART1_Write_CText("Calibration en Cours...\r\n");
   LCD_putcmd(LCD_LINE1,1);               //12345678901234567890
   LCD_putsRom((const code unsigned char *)"Calibration CCal 1nF");
   Delay_ms(500);
             k1= Take_Fx(1);
             f1 =(float) k1 ;
  // WordToStr(k1,txt);
  // UART1_Write_CText("K1 = ");
  // UART1_Write_Text(txt);
  // CRLF1();
    k2= Take_Fx(2);
   
   if ((k1<2560) || (Cpt1>0) || (k2==0) )
   {
      LCD_CLS();
      LCD_putcmd(LCD_LINE2,1);
            //     12345678901234567890
      LCD_putsRom("Problem values K1,K2");
      LCD_putcmd(LCD_LINE3,1);
      LCD_putsRom("Check Oscillat.LM311");
      LCD_putcmd(LCD_LINE4,1);
      LCD_putsRom("Reset MCU wihtin 10s");
      UART1_Write_CText("\r\nPB on LM311 ? => RESET dans 10sec\r\n");
      Delay_ms(10000);
      _asm RESET;
   }
    else
   {
    f2= (float) k2;
   // WordToStr(k2,txt);
  //  UART1_Write_CText("K2 = ");
  //  UART1_Write_Text(txt);
  //  CRLF1();
    f12=f1/f2;
    Float2Ascii (f12,CRam1,4);
    UART1_Write_CText("(F1/F2)  = ");
    UART1_Write_Text(CRam1);
    CRLF1();
    f12=(f12*f12) - 1.0;
    Float2Ascii (f12,CRam1,4);
    UART1_Write_CText("(F1/F2)^2 -1  = ");
    UART1_Write_Text(CRam1);
    CRLF1();
    Relay_CCal=0;
    Delay_ms(2000);
    MemoModeLC=0;
   }
  }
   
void Choix_CapaciMetre()
{
   UART1_Write_CText("Mode Capacimetre\r\n");
   LCD_putcmd(LCD_LINE1,1);
   LCD_putsRom((const code unsigned char *)"Mode Capacimetre    ");
   Relais_LC=1;  // commande inverse 1=repos
   Delay_ms(1000);
 }
 
 void  Choix_SelfMetre()
  {
      UART1_Write_CText("Mode SelfMetre\r\n");
      LCD_putcmd(LCD_LINE1,1);
      LCD_putsRom((const code unsigned char *)"Mode SelfMetre      ");
      Relais_LC=0; // commande inverse 0= activ
      Delay_ms(1000);
   }

void main()
 {
  // Internal FOSC is 500Khz by default !
  #ifdef OSCILLATEUR_INTERNE
  OSCCON =0;        // PLL disbled
  OSCCON.IRCF3=1;         //8 MHz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=0;
  OSCCON.SCS1=1;  // internal FOSC
  #endif

  Init_Hardware() ;
  
  Relais_LC=1;     // 1 = relais au repos
  Relay_CCal=0;    // 0 = relais au repos

  txt=TEXTE; // init pointeur
  UART1_Init(9600); // Hardware UART init won't work with RB2 as RX  , and  RB5 as TX is OK
  Delay_ms(100);
  // ecraser la config UART precedente..  faire Apres, sinon RX RB2 mal configur
  Special_Init_UART1_RB2_RB5();
  Delay_ms(100);
  while(PIR1.RCIF==1) c1 = RCREG;
  UART1_Write(CLS);
  Delay_ms(500);
  UART1_Write_CText("\r\n Init Speciale UART: Rx RB2 et TX RB5\r\n");
  for (i=1;i<4;i++)  UART1_Write_CText(Messages[i]);
  CRLF1();
  Read_Msg_Eeprom(0);
  Read_Msg_Eeprom(0x20);
  Read_Msg_Eeprom(0x40);
  CRLF1();

   RAZ_UART1();
   PIE1.RCIE=1; // Enables the USART receive interrupt
   PEIE_bit=1; // INTCON  Enables all active peripheral interrupts
   GIE_bit=1;  // INTCON   Global Interrupt Enable bit

 #ifdef Test_UART
   do
   {
   RAZ_UART1();
   Delay_ms(1000);
   
    if( UART1_DataReady==1)
   {
    UART1_Write_CText("Recu : ") ;
    UART1_Write_Text(buffer1);
    CRLF1();
   }
   }while(1);
#endif

  
#ifdef With_LCD_I2C
   I2C1_Init(400000);

  // adrr= adresse du PCF8754 du LCD4x20
  addr=LCD_ADDR;
  LCD_init_4x20();
  LCD_putcmd(LCD_CLEAR,1);  // LCD Clear
  Delay_ms(1000);
 // LCD_putcmd(LCD_LINE1,1);  Delay_ms(25);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
  //LCD_putsRom((const code unsigned char *)"16F1847 8MHz MikroC ");
  LCD_putcmd(LCD_LINE1,1);
  LCD_putsRom((const code unsigned char *)"Version : "Version );
  LCD_putcmd(LCD_LINE2,1);
  LCD_putsRom((const code unsigned char *)"LCMeter LM311 100uH ");
  LCD_putcmd(LCD_LINE3,1);
  LCD_putsRom((const code unsigned char *)"//1nF + CCal 1nF  1%");
   LCD_putcmd(LCD_LINE4,1);
  LCD_putsRom((const code unsigned char *)"RB6= Freq.input TMR1");
  Delay_ms(3500);
   LCD_CLS();
   LCD_putsRom((const code unsigned char *)"16F1847 LCMeter AOP ");
  #endif

  Init_Timer1();
  
   Calibration_CCal();
   
   RAZ_UART1();
   PIE1.RCIE=1; // Enables the USART receive interrupt
   PEIE_bit=1; // INTCON  Enables all active peripheral interrupts
   GIE_bit=1;  // INTCON   Global Interrupt Enable bit
   

 do
 {
   // choix via Switch Hardware
  #ifdef Cde_by_Harware
   if( Demande_Cal==1)
   {
    Calibration_CCal() ;

   }
   if (Choix_LC==1)
       { MemoModeLC=1;
       Choix_SelfMetre();
       }
       else
       { MemoModeLC=0;
         Choix_CapaciMetre();
         }
  #else
  // choix via Cde UART
  //if( UART1_Data_Ready())
  //{
   if( UART1_DataReady==1)
   {
    UART1_Write_CText("Recu : ") ;
    UART1_Write_Text(buffer1);
    CRLF1();
    p=strstr(buffer1,"RESET");
    if (p>0)
    {
     LCD_CLS();                           //  12345678901234567890
     LCD_putsRom((const code unsigned char *)"RESET MCU 16F1847   ");
     Delay_ms(5000);
     _asm RESET;
    }
    p=strstr( buffer1,"Calibre");
    if  (p>0)
     {
      Relais_LC=0;
      Delay_ms(1000);
      Calibration_CCal() ;
    }
    p=strstr( buffer1,"Capa") ;
    if(p>0)
      {
       MemoModeLC=0;
      // Choix_CapaciMetre();
     }
    p=strstr( buffer1,"Self");
    if(p>0)  
     { 
       MemoModeLC=1;
      // Choix_SelfMetre();
    }
    p=strstr( buffer1,"Test");
    if(p>0) 
    {  
       LCD_putcmd(LCD_LINE1,1);          //     12345678901234567890
       strConstRamCpy(txt,"Test valeurs F1 F2  ");
       LCD_puts(txt);
      
       Relay_CCal=0;
       Relais_LC=0;
       Delay_ms(1500);
       k1= Take_Fx(1);
       // f1 =(float) k1 ;
     //  WordToStr(k1,txt);
     //  UART1_Write_CText("K1 = ");
     //  UART1_Write_Text(txt);
       k=k1/20;  // 5%
       LCD_putcmd(LCD_LINE1,1);
       Stabilite=0;
       if ((k1 > (k1+k)) || (k1 < (k1-k)))
        {
          strConstRamCpy(txt,"F1 Ecart>5% Instable");
          }
            else
              {
                strConstRamCpy(txt,"...F1 Stable .      ");
                Stabilite++;
                }
       LCD_puts(txt);
       UART1_Write_Text(txt);
       CRLF1()  ;
       k2=Take_Fx(2);
       //f2 =(float) k2 ;
      // WordToStr(k2,txt);
      // UART1_Write_CText("K2 = ");
      // UART1_Write_Text(txt);
       k=k2/20;  // 5%
       if ((k2 > (F2Nominal+k)) || (k2 < (F2Nominal-k)))
        {
          strConstRamCpy(txt,"F2 Ecart>5% Instable");
          }
            else
            {
              strConstRamCpy(txt,"...F2 Stable .      ");
              Stabilite++  ;
              }
       LCD_puts(txt);
       UART1_Write_Text(txt);
       CRLF1()  ;
      
      f1 =(float) k1 ;
      f2 =(float) k2 ;
      if (Stabilite==2)
      {
      f12=f1/f2;
      Float2Ascii (f12,CRam1,4);
      UART1_Write_CText("Rapport F1/F2 = ");
      UART1_Write_Text(CRam1);
      CRLF1();
      f12=(f12*f12) - 1.0;
      Float2Ascii (f12,CRam1,4);
      UART1_Write_CText("(F1/F2)^2 -1  = ");
      UART1_Write_Text(CRam1);
      CRLF1();
      }
      else
        {
        UART1_Write_CText("Attention, Trop instable ...\r\n");
        CRLF1();
        }
       Relay_CCal=0;
       Delay_ms(3000);
     }
     RAZ_UART1();
    } // if UART..
    #endif
   
   if( MemoModeLC==0)
   {
    Choix_CapaciMetre();
    k3= Take_Fx(3);
    f3 =(float) k3 ;
    Erase_Line(2);

  // WordToStr(k1,txt);
  // UART1_Write_CText("K3 = ");
  // UART1_Write_Text(txt);
  // CRLF1();

    f13=f1/f3;
    f13=(f13*f13) - 1.0;
   
    Float2Ascii (f13,CRam1,4);
    UART1_Write_CText("(F1/F3)^2 -1  = ");
    UART1_Write_Text(CRam1);
    CRLF1();
                     //  12345678901234567890
     strConstRamCpy(txt,"F12 =:              ");
    Float2Ascii (f12,CRam1,4);
    k=strlen(CRam1);
    memcpy(txt+20-k,CRam1,k );
     LCD_putcmd(LCD_LINE3,1);
     LCD_puts(txt);
   
   
    strConstRamCpy(txt,"CX :              pF");
    Cx=  1000.0 * f13/f12;
    Float2Ascii (Cx,CRam1,1);
    k=strlen(CRam1);
    memcpy(txt+18-k,CRam1,k );
    UART1_Write_Text(txt);
     LCD_putcmd(LCD_LINE4,1);
     LCD_puts(txt);
    CRLF1();
    Delay_ms(1000);
    }
    if( MemoModeLC==1)
   {
    Choix_SelfMetre();
    k3= Take_Fx(3);
   f3 =(float) k3 ;
   Erase_Line(2);
   //WordToStr(k1,txt);
   //UART1_Write_CText("K3 = ");
   //UART1_Write_Text(txt);
   //CRLF1();

    f13=f1/f3;
    f13=(f13*f13) - 1.0;
    
     strConstRamCpy(txt,"F12 =:              ");
    Float2Ascii (f12,CRam1,4);
    k=strlen(CRam1);
    memcpy(txt+20-k,CRam1,k );
     LCD_putcmd(LCD_LINE3,1);
     LCD_puts(txt);

    Float2Ascii (f13,CRam1,4);
    UART1_Write_CText("(F1/F3)^2 -1  = ");
    UART1_Write_Text(CRam1);
    CRLF1();
    f14=  Rapport / (f1*f1);
    f14=f14/1000.0;
    strConstRamCpy(txt,"LX :              uH");
    Lx=f13*f12*f14;
    Float2Ascii (Lx,CRam1,1);
    k=strlen(CRam1);
   // memcpy(txt+5,CRam1,14-k );
    memcpy(txt+18-k,CRam1,k );
    UART1_Write_Text(txt);

     LCD_putcmd(LCD_LINE4,1);
     LCD_puts(txt);

    CRLF1();
    }
     

   //Tempo_XmS(500);
   j++;

     Delay_ms(1000);
   
    }
  while(1);
 }
  
  
  
  
  


 /*
 Test UART TX & RX

 Init Speciale UART: Rx RB2 et TX RB5
 Compilateur : MikroC 7.0.0
 Directory :C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311
 Projet    :16F1847_LCMeter_BT_2017.mcppi

PIC16F1847 8MHZ
LC Meter
Gamme L : 1uH  10000 mH
Gamme C : 1pF  10000nF

Recu : Self
Recu : GREEN_ON
Recu : Msg=COUCOU C'est Moi PAULO



 Init Speciale UART: Rx RB2 et TX RB5
 Compilateur : MikroC 7.0.0
 Directory :C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311
 Projet    :16F1847_LCMeter_BT_2017.mcppi

PIC16F1847 8MHZ
LC Meter
Gamme L : 1uH  10000 mH
Gamme C : 1pF  10000nF

F1(Zero=1nf):     00
K1 =     0
F2 Scale=2nf:     00

PB on LM311 ? => RESET dans 10sec


 Init Speciale UART: Rx RB2 et TX RB5
 Compilateur : MikroC 7.0.0
 Directory :C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311
 Projet    :16F1847_LCMeter_BT_2017.mcppi

PIC16F1847 8MHZ
LC Meter
Gamme L : 1uH  10000 mH
Gamme C : 1pF  10000nF

F1(Zero=1nf):     00
K1 =     0
F2 Scale=2nf: 392100

PB on LM311 ? => RESET dans 10sec


 Init Speciale UART: Rx RB2 et TX RB5
 Compilateur : MikroC 7.0.0
 Directory :C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311
 Projet    :16F1847_LCMeter_BT_2017.mcppi

PIC16F1847 8MHZ
LC Meter
Gamme L : 1uH  10000 mH
Gamme C : 1pF  10000nF

F1(Zero=1nf): 554830
K1 = 55483
F2 Scale=2nf: 390290
K2 = 39029
(F1/F2)  = 1.4216
(F1/F2)^2 -1  = 1.0209
Mode Capacimetre
F3(Cx):       554830
K3 = 55483
(F1/F3)^2 -1  = 0.0000
CX : 0.0
Mode Capacimetre

 0 1 mikroCPIC1618.exe -MSF -DBG -pP16F1847 -RA -C -O11111004 -fo8 -N"C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311\16F1847_LCMeter_BT_2017.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311\16F1847_LCMeter_BT_2017_Eeprom.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311\" -SP"C:\_MikroC\_MesProjets_MikroC\_FingerPrint_Clicker2_18F87J50\" -SP"C:\_MikroC\_MesProjets_MikroC\common\" -SP"C:\_MikroC\_MesProjets_MikroC\_LIB_LCD_I2C\" -SP"C:\_MikroC\_MesProjets_MikroC\_16F1847_1827\" -IP"C:\_MikroC\_MesProjets_MikroC\_16F1847_LC_Meter_LM311\" -IP"C:\_MikroC\_MesProjets_MikroC\common\" "_16F1847_LCMeter_BT_170128.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_CMath.mcl" "__Lib_Conversions.mcl" "__Lib_ADC.mcl" "__Lib_EEPROM.mcl" "__Lib_I2C_b14b25.mcl" "__Lib_UART_b21.mcl"
0 1139 Available RAM: 1008 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F1847.c
1400 123 Compiled Successfully P16F1847.c
0 122 Compilation Started __Lib_Delays.c
123 123 Compiled Successfully __Lib_Delays.c
6 1354  warning: The macro is redefined     #define POWER_SUPPLY DC_5V     from C:/_MikroC/_MesProjets_MikroC/_16F1847_LC_Meter_LM311/_16F1847_LCMeter_BT_170128.c: 94:    #include "../common/Lib_LCD_I2C.h"     previously macro "POWER_SUPPLY" defined as: #define POWER_SUPPLY  "5V"  c:\_mikroc\_mesprojets_mikroc\_16f1847_lc_meter_lm311\..\common\lib_lcd_i2c.h
7 1354  warning: The macro is redefined     #define FOSC 8.0     from C:/_MikroC/_MesProjets_MikroC/_16F1847_LC_Meter_LM311/_16F1847_LCMeter_BT_170128.c: 94:    #include "../common/Lib_LCD_I2C.h"     previously macro "FOSC" defined as: #define FOSC  " Q=8MHz"  c:\_mikroc\_mesprojets_mikroc\_16f1847_lc_meter_lm311\..\common\lib_lcd_i2c.h
0 122 Compilation Started lib_lcd_i2c.h
37 1504 Initialization of extern object 'mesg0' lib_lcd_i2c.h
0 1004 interrupt handler (Interrupts at 0x0004) _16F1847_LCMeter_BT_170128.c
344 1163 Variable 'adpt' has been declared, but not used _16F1847_LCMeter_BT_170128.c
532 1509 Generated baud rate is 9615 bps (error = 0.16 percent) _16F1847_LCMeter_BT_170128.c
801 123 Compiled Successfully _16F1847_LCMeter_BT_170128.c
70 1164 Variable 'dummy' has been eliminated by optimizer _16F1847_LCMeter_BT_170128.c
392 1164 Variable 'x' has been eliminated by optimizer _16F1847_LCMeter_BT_170128.c
0 127 All files Compiled in 94 ms
0 1144 Used RAM (bytes): 425 (42%)  Free RAM (bytes): 583 (58%) Used RAM (bytes): 425 (42%)  Free RAM (bytes): 583 (58%)
0 1144 Used ROM (program words): 6543 (80%)  Free ROM (program words): 1649 (20%) Used ROM (program words): 6543 (80%)  Free ROM (program words): 1649 (20%)
0 125 Project Linked Successfully 16F1847_LCMeter_BT_2017.mcppi
0 128 Linked in 47 ms
0 129 Project '16F1847_LCMeter_BT_2017.mcppi' completed: 266 ms
0 103 Finished successfully: 28 janv. 2017, 15:51:53 16F1847_LCMeter_BT_2017.mcppi


*/